//*******************************************************
//       Copyright (c) 2003 Gena A. Petrov
//*******************************************************

unit FCConsts;

interface

const
  SMacrosHandler = 'MacrosHandler';
var
  SResNotFound,
  SError,
  SCantGet,
  SCantSet,
  SCantExecMacros,
  SMacrosError,
  SClassNotFound,
  SPropertyNotfound,
  SAssignExpected,
  SInvalidAssignChars,
  SInvalidOperatorChars,
  SUnExpectedChar,
  SUnExpectedInteger,
  SUnExpectedString,
  SUnExpectedSet: String;

implementation
uses
  ResourceStringsManage;

initialization

  // xFMHandle
  SResNotFound := 'Resource %s not found';

  // PropEditors
  SError := 'Error';
  SCantGet := 'Can`t get property value';
  SCantSet := 'Can`t set property value';

  // MacrosHandler
  SCantExecMacros := 'Can`t execute macros';
  SMacrosError := 'Error on executing macros';
  SClassNotFound := 'Class %s not found!';
  SPropertyNotfound := 'Property or method in class %s not found!';
  SAssignExpected := '"=" expected';
  SInvalidAssignChars := '"=" or ":","+","-" expected';
  SInvalidOperatorChars := 'Operators chars is "A,B,c,d" after may be is numbers';
  SUnExpectedChar := 'UnExpected Char';
  SUnExpectedInteger := sUnExpectedChar + '. For example: "109" or in hex form "$6D"';
  SUnExpectedString := sUnExpectedChar + '. Possible: "word" or '#39'word'#39;
  SUnExpectedSet := sUnExpectedChar + '. Possible: "[item1,item2]" or "(item1,item2)" or "item1,item2"';

  with ResourceStringsManager do
  begin
    // xFMHandle
    SetStringValue('SResNotFound', SResNotFound);

    // PropEditors
    SetStringValue('SError', SError);
    SetStringValue('SCantGet', SCantGet);
    SetStringValue('SCantSet', SCantSet);

    // MacrosHandler
    SetStringValue('SCantExecMacros', SCantExecMacros);
    SetStringValue('SMacrosError', SMacrosError);
    SetStringValue('SClassNotFound', SClassNotFound);
    SetStringValue('SPropertyNotfound', SPropertyNotfound);
    SetStringValue('SAssignExpected', SAssignExpected);
    SetStringValue('SInvalidAssignChars', SInvalidAssignChars);
    SetStringValue('SInvalidOperatorChars', SInvalidOperatorChars);
    SetStringValue('SUnExpectedChar', SUnExpectedChar);
    SetStringValue('SUnExpectedInteger', SUnExpectedInteger);
    SetStringValue('SUnExpectedString', SUnExpectedString);
    SetStringValue('SUnExpectedSet', SUnExpectedSet);

    Update;
  end;

end.
