//*******************************************************
//       Copyright (c) 2000-3 Gena A. Petrov
//*******************************************************
unit StrList;

interface

uses
  Windows, Messages;

type
  PStrList = ^TStrList;
  TStrList = array of string;

  function StrToStrList(const Str: string): TStrList;
  function StrCharToStrList(Chr: Char; const Str: string): TStrList;

  function StrSlashToStrList(Str: string): TStrList;
  function StrPointToStrList(Str: string): TStrList;
  procedure FreeStrList(var StrList: TStrList);

implementation

uses
  StrOperation,
  SysUtils;

procedure FreeStrList(var StrList: TStrList);
var
  i: Integer;
begin
  for i:= 0 to length(StrList)-1 do
  begin
    SetLength(StrList[i],0); 
  end;
  SetLength(StrList,0);
end;

function IsAddItems(var CountL,CountAbs: Integer; var StrList: TStrList): Boolean;
begin
  Result:= False;
  if CountL = CountAbs then
  begin
    CountL:= CountAbs + 5;
    SetLength(StrList, CountL);
    Result:= True;
  end;
end;

function StrToStrList(const Str: string): TStrList;
var
  CountAbs,
  CountL: Integer;
  L,
  i,
  i0: Integer;

begin
  CountL:= 0;
  CountAbs:= 0;

  L:= length(Str);

  i0:= 1;
  for i:= 1 to L-1 do
  begin
    if (Str[i]= ';') or (Str[i]= ',') then
    begin
      IsAddItems(CountL,CountAbs,Result);
      Result[CountAbs]:= copy_(Str,i0,i-1);

      i0:= i+1;
      if Result[CountAbs] <> '' then
        Inc(CountAbs);
    end;
  end;
  IsAddItems(CountL,CountAbs,Result);
  if (Str[L]= ';') or (Str[L]= ',') then
    Dec(L);

  Result[CountAbs]:= copy_(Str,i0,L);
  if Result[CountAbs] <> '' then
    Inc(CountAbs);

  SetLength(Result, CountAbs);
end;

function StrCharToStrList(Chr: Char; const Str: string): TStrList;
var
  CountAbs,
  CountL: Integer;
  L,
  i,
  i0: Integer;

begin
  CountL:= 0;
  CountAbs:= 0;

  L:= length(Str);

  i0:= 1;
  for i:= 1 to L-1 do
  begin
    if Str[i]= Chr then
    begin
      IsAddItems(CountL,CountAbs,Result);
      Result[CountAbs]:= Copy_(Str,i0,i-1);

      i0:= i+1;
      if Result[CountAbs] <> '' then
        Inc(CountAbs);
    end;
  end;
  IsAddItems(CountL,CountAbs,Result);
  if Str[L] = Chr then
    Dec(L);

  Result[CountAbs]:= copy_(Str,i0,L);
  if Result[CountAbs] <> '' then
    Inc(CountAbs);

  SetLength(Result, CountAbs);
end;


function StrSlashToStrList(Str: string): TStrList;
begin
  Result:= StrCharToStrList('\',Str);
end;

function StrPointToStrList(Str: string): TStrList;
begin
  Result:= StrCharToStrList('.',Str);
end;

end.

